import { BlockSource, BlockSourceType, Converter, Source } from "univ-conv";
import { AbstractEntry } from "./AbstractEntry";
import { AbstractFileSystem } from "./AbstractFileSystem";
import { BlockReadOptions, DeleteOptions, ErrorLike, File, OpenOptions, WriteOptions } from "./core";
export declare abstract class AbstractFile extends AbstractEntry implements File {
    private afterGet?;
    private afterPost?;
    private afterPut?;
    private beforeGet?;
    private beforePost?;
    private beforePut?;
    constructor(fs: AbstractFileSystem, path: string);
    _convert(converter: Converter, chunk: Source, type: BlockSourceType): Promise<BlockSource>;
    _delete(options: DeleteOptions, _errors: ErrorLike[]): Promise<void>;
    hash(options?: OpenOptions): Promise<string>;
    readAll(options?: BlockReadOptions): Promise<BlockSource>;
    writeAll(src: Source, options?: WriteOptions): Promise<void>;
    protected abstract _getSource(): Promise<Source>;
    protected abstract _rm(): Promise<void>;
    protected abstract _writeAll(src: Source, options: WriteOptions): Promise<void>;
    private _getConverter;
    private getSource;
}
//# sourceMappingURL=AbstractFile.d.ts.map